load params

EPSW = EPSW;
EPSP = EPSP;
PHIW = PHIW;
PHIP = PHIP;
SPREAD = SPREAD;
DELTA = DELTA;
ALPHA = ALPHA;
TREAS2DEBT = TREAS2DEBT;

pinf = pinf;
h = h;
phi = phi;
r = r;
re = re;

PINFSS = pinf;
RESS = re;
rl = (r^4+SPREAD/10000)^0.25;

SP = EPSP/(EPSP-1)-1;
SW = (EPSW-1)/EPSW-1;

% (C.1)
BETA = pinf/r;
KAPPA = ((DURATION - 1)/DURATION)/BETA;

KHD = ((1*(1-BETA*(1-DELTA)))/BETA/ALPHA)^(1/(ALPHA-1));

% (C.16)
q = 1/(rl-KAPPA);

% (C.8)
xi = BETA/(pinf-BETA*KAPPA)/q;

% (C.13)
ZETA = pinf/BETA/(r+(rl-r)*phi);

% (C.14)
EPSF = (r+(rl-r)*phi)/phi/rl;

% (C.12)
pstar = ((1-PHIP*pinf^(EPSP-1))/(1-PHIP))^(1/(1-EPSP));

% (C.11)
vp = (1-PHIP)*pstar^(-EPSP)/(1-PHIP*pinf^EPSP);

% (C.10)
mc = (EPSP-1)/EPSP*pstar*(1-PHIP*BETA*pinf^EPSP)/(1-PHIP*BETA*pinf^(EPSP-1));

% (C.5)
WSTARW = ((1-PHIW*pinf^(EPSW-1))/(1-PHIW))^(1/(1-EPSW));

% (C.4)
vw = (1-PHIW)*WSTARW^(-EPSW)/(1-PHIW*pinf^EPSW);

% (C.3)
hd = h/vw;

% (C.7)
k = ((1-BETA*(1-DELTA))/BETA/ALPHA)^(1/(ALPHA-1))*hd;
SK = xi*(1/BETA-(1-DELTA))/mc/ALPHA/(k/hd)^(ALPHA-1)-1;

% (C.9)
f = DELTA*k/q/(1-KAPPA/pinf);

BG = TREAS2DEBT*f/(1-TREAS2DEBT);

% (C.15)
n = (q*(f+BG)-re)/phi;
NSS = n;

% (C.17)
c = k^ALPHA*hd^(1-ALPHA)/vp-DELTA*k;

% (C.6)
w = (1+SP)*mc*(1-ALPHA)*k^ALPHA*hd^(-ALPHA);
wstar = WSTARW*w;

% (C.2)
PSI = wstar*(EPSW-1)/EPSW/(1+SW)*(1-PHIW*BETA*pinf^EPSW)/(1-PHIW*BETA*pinf^(EPSW-1))/(h^ETA)/(c^GAMMA);

% Remaining variables
yw = k^ALPHA*hd^(1-ALPHA);
y = yw/vp;
inv = DELTA*k;
bcb = re/q;
b = BG - bcb;
lamn = BETA/pinf;
lam = lamn*pinf;
x1 = mc*y/(1-PHIP*lam*pinf^EPSP);
x2 = y/(1-PHIP*lam*pinf^(EPSP-1));
wh = PSI*h^ETA*c^GAMMA;
g1 = wh*w^EPSW*hd/(1-PHIW*lam*pinf^EPSW);
g2 = w^EPSW*hd/(1-PHIW*lam*pinf^(EPSW-1));
pk = 1;
rlong = 1/q+KAPPA;
qeh = 1/(r-KAPPA);
rlongeh = 1/qeh+KAPPA;
tp = rlong-rlongeh;
YSS = y;
