warning off 
 
// Endogenous variables 
var Util, 
Welf, 
instr1, 
instr2,Util1 Util2 
    y yw c k inv h hd f n phi re r mc pinf pstar x1 x2  
    vp wh w wstar g1 g2 vw pk xi q rl,  
flag,  
invlag,  
klag,  
nlag,  
qlag,  
rlag,  
vplag,  
vwlag,  
wlag;  
    // b bcb rlong qeh rlongeh tp real epinf  
    // bal2y 
    // yf ywf cf kf invf hf hdf ff nf phif bf bcbf ref lamnf lamf rf mcf pinff pstarf 
    // vpf whf wf wstarf vwf pkf xif qf rlf bal2yf; 
 
// Exogenous variables 
var epsa epsf epsi epsn; 
 
varexo ea en ef ei; 
 
parameters  BETA ZETA GAMMA PSI ETA ALPHA DELTA KAPPA EPSP EPSW PINFSS RESS 
omega_welf1, 
omega_welf2, 
nbeta,            PHIP PHIW PHII PHIN RHOR UPSIPI UPSIY INF_TARG PREM_TARG NSS BG 
            RHOA SIGA RHON SIGP RHOF SIGF EPSF RHOI SIGI SIGR YSS 
            RHORE1 RHORE2 SIGRE SK SW SP RLONGSS; 
 
var lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11,  lmult12,  lmult13,  lmult14,   
    lmult15,  lmult16,  lmult17,  lmult18,  lmult19,  lmult20,  lmult21,   
    lmult22,  lmult23,  lmult24,  lmult25,  lmult26,  lmult27,  lmult28,   
    lmult29,  lmult30,  lmult31,  lmult32,  lmult33,  lmult34,  lmult35,   
    lmult36,  lmult37,  lmult38,  lmult39,  Welf1,  Welf2; 
  
model; 
 
////////////////////////////////// 
// Utility and Welfare bloc 
////////////////////////////////// 
 
// Utility, aggregate  
Util = omega_welf1*Util1+omega_welf2*Util2; 
 
// Welfare, aggregate  
Welf = Util + nbeta*Welf(1); 
 
//// Welfare, agent 1 
Welf1 = Util1 + nbeta*Welf1(1); 
 
//// Welfare, agent 2 
Welf2 = Util2+ nbeta*Welf2(1); 
 
// Policy instrument, agent 1 
instr1 = r; 
 
// Policy instrument, agent 2 
instr2 = re; 
 
 flag =f(-1);  // lmult3
invlag =inv(-1);  // lmult4
klag =k(-1);  // lmult5
nlag =n(-1);  // lmult6
qlag =q(-1);  // lmult7
rlag =r(-1);  // lmult8
vplag =vp(-1);  // lmult9
vwlag =vw(-1);  // lmult10
wlag =w(-1);  // lmult11
 // OPTIMAL MONETARY POLICY 
// Policymaker's First-Order Conditions 
(lmult37(-1)*((BETA*GAMMA*c(-1)*epsn*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*pinf) - (BETA*GAMMA*c(-1)*epsn*epsf(-1)*phi(-1)*rl*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*pinf)))/nbeta - lmult37*((BETA*GAMMA*epsn(+1)*(r - phi*(r - rl(+1)))*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*epsf*epsn(+1)*phi*rl(+1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1))) - (epsn*lmult12)/c^GAMMA - (epsn*lmult13)/c^GAMMA - lmult39 - GAMMA*PSI*c^(GAMMA - 1)*h^ETA*lmult15 + (BETA*GAMMA*epsn(+1)*lmult23*(pk(+1)*xi(+1)*(DELTA - 1) - (ALPHA*mc(+1)*yw(+1)*(SK + 1))/k)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*epsn(+1)*lmult14*r*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*epsn(+1)*lmult25*(c/c(+1))^(GAMMA - 1)*(KAPPA*q(+1)*xi(+1) + 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*PHIP*epsn(+1)*lmult30*pinf(+1)^(EPSP - 1)*x2(+1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*ZETA*epsn(+1)*lmult36*(r - phi*(r - rl(+1)))*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn*pinf(+1)) - (BETA*GAMMA*c(-1)*epsn*lmult23(-1)*(pk*xi*(DELTA - 1) - (ALPHA*mc*yw*(SK + 1))/k(-1))*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) - (BETA*GAMMA*PHIW*epsn(+1)*g1(+1)*lmult17*pinf(+1)^EPSW*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*PHIP*epsn(+1)*lmult29*pinf(+1)^EPSP*x1(+1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) - (BETA*GAMMA*PHIW*epsn(+1)*g2(+1)*lmult18*pinf(+1)^(EPSW - 1)*(c/c(+1))^(GAMMA - 1))/(c(+1)*epsn) + (BETA*GAMMA*c(-1)*epsn*lmult14(-1)*r(-1)*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta*pinf) + (BETA*GAMMA*c(-1)*epsn*lmult25(-1)*(c(-1)/c)^(GAMMA - 1)*(KAPPA*q*xi + 1))/(c^2*epsn(-1)*nbeta*pinf) + (BETA*GAMMA*PHIW*c(-1)*epsn*g2*lmult18(-1)*pinf^(EPSW - 1)*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) + (BETA*GAMMA*PHIP*c(-1)*epsn*lmult30(-1)*pinf^(EPSP - 1)*x2*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) + (BETA*GAMMA*ZETA*c(-1)*epsn*lmult36(-1)*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta*pinf) + (BETA*GAMMA*PHIW*c(-1)*epsn*g1*lmult17(-1)*pinf^EPSW*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) + (BETA*GAMMA*PHIP*c(-1)*epsn*lmult29(-1)*pinf^EPSP*x1*(c(-1)/c)^(GAMMA - 1))/(c^2*epsn(-1)*nbeta) - (BETA*GAMMA*PHII*epsi(+1)*epsn(+1)*inv(+1)^2*lmult24*pk(+1)*xi(+1)*(c/c(+1))^(GAMMA - 1)*(inv(+1)/inv - 1))/(c(+1)*epsn*inv^2*xi) + (BETA*GAMMA*PHII*c(-1)*epsi*epsn*inv^2*lmult24(-1)*pk*xi*(c(-1)/c)^(GAMMA - 1)*(inv/inv(-1) - 1))/(c^2*epsn(-1)*inv(-1)^2*nbeta*xi(-1)); 
- lmult3(+1)*nbeta - lmult27*q - lmult38*q; 
lmult3 + (KAPPA*lmult27*q)/pinf; 
lmult17 - (EPSW*lmult16*(SW + 1))/(g2*(EPSW - 1)) - (BETA*PHIW*epsn*lmult17(-1)*pinf^EPSW*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 
lmult18 + (EPSW*g1*lmult16*(SW + 1))/(g2^2*(EPSW - 1)) - (BETA*PHIW*epsn*lmult18(-1)*pinf^(EPSW - 1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 
lmult19 + PSI*epsn*h^ETA*lmult12 + PSI*epsn*h^ETA*lmult13 - ETA*PSI*c^GAMMA*h^(ETA - 1)*lmult15; 
(epsa*klag^ALPHA*lmult31*(ALPHA - 1))/hd^ALPHA - lmult18*w^EPSW - lmult17*w^EPSW*wh - lmult19*vw - (lmult22*mc*yw*(ALPHA - 1)*(SP + 1))/hd^2; 
lmult1; 
lmult2; 
lmult27 - lmult39 - lmult4(+1)*nbeta + lmult26*(epsi*((PHII*(inv/invlag - 1)^2)/2 - 1) + (PHII*epsi*inv*(inv/invlag - 1))/invlag) + lmult24*(epsi*pk*((2*PHII*(inv/inv(-1) - 1))/inv(-1) + (PHII*inv)/inv(-1)^2) + (BETA*PHII*epsi(+1)*epsn(+1)*inv(+1)^3*pk(+1)*xi(+1)*(c/c(+1))^GAMMA)/(epsn*inv^4*xi) + (2*BETA*PHII*epsi(+1)*epsn(+1)*inv(+1)^2*pk(+1)*xi(+1)*(c/c(+1))^GAMMA*(inv(+1)/inv - 1))/(epsn*inv^3*xi)) - (lmult24(-1)*((BETA*PHII*epsi*epsn*inv^2*pk*xi*(c(-1)/c)^GAMMA)/(epsn(-1)*inv(-1)^3*xi(-1)) + (2*BETA*PHII*epsi*epsn*inv*pk*xi*(c(-1)/c)^GAMMA*(inv/inv(-1) - 1))/(epsn(-1)*inv(-1)^2*xi(-1))))/nbeta - epsi(+1)*lmult24(+1)*nbeta*pk(+1)*((PHII*inv(+1)^2)/inv^3 + (2*PHII*inv(+1)*(inv(+1)/inv - 1))/inv^2); 
lmult4 - (PHII*epsi*inv^2*lmult26*(inv/invlag - 1))/invlag^2; 
lmult26 - lmult5(+1)*nbeta + (ALPHA*BETA*epsn(+1)*lmult23*mc(+1)*yw(+1)*(c/c(+1))^GAMMA*(SK + 1))/(epsn*k^2); 
lmult5 + lmult26*(DELTA - 1) - ALPHA*epsa*hd^(1 - ALPHA)*klag^(ALPHA - 1)*lmult31; 
(lmult22*yw*(ALPHA - 1)*(SP + 1))/hd - lmult29*y - (ALPHA*BETA*epsn*lmult23(-1)*yw*(c(-1)/c)^GAMMA*(SK + 1))/(epsn(-1)*k(-1)*nbeta); 
lmult36*((2*PHIN*(n/NSS - 1))/NSS + (PHIN*n)/NSS^2) - lmult6(+1)*nbeta + lmult38*phi - (PHIN*lmult39*(n/NSS - 1))/NSS; 
lmult6; 
lmult37*((BETA*epsn(+1)*(c/c(+1))^GAMMA*(r - rl(+1)))/(epsn*pinf(+1)) + (BETA*epsf*epsn(+1)*rl(+1)*(c/c(+1))^GAMMA)/(epsn*pinf(+1))) + lmult38*n + (BETA*ZETA*epsn(+1)*lmult36*(c/c(+1))^GAMMA*(r - rl(+1)))/(epsn*pinf(+1)); 
(lmult37(-1)*((BETA*epsn*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf^2) - (BETA*epsn*epsf(-1)*phi(-1)*rl*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf^2)))/nbeta - PHIP*lmult34*pinf^(EPSP - 2)*(EPSP - 1) - PHIW*lmult21*pinf^(EPSW - 2)*wlag^(1 - EPSW)*(EPSW - 1) - EPSP*PHIP*lmult33*pinf^(EPSP - 1)*vplag - (KAPPA*flag*lmult27*q)/pinf^2 - EPSW*PHIW*lmult20*pinf^(EPSW - 1)*vwlag*(w/wlag)^EPSW + (BETA*epsn*lmult14(-1)*r(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf^2) + (BETA*epsn*lmult25(-1)*(c(-1)/c)^GAMMA*(KAPPA*q*xi + 1))/(epsn(-1)*nbeta*pinf^2) + (BETA*ZETA*epsn*lmult36(-1)*(r(-1) - phi(-1)*(r(-1) - rl))*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf^2) - (BETA*PHIW*epsn*g2*lmult18(-1)*pinf^(EPSW - 2)*(c(-1)/c)^GAMMA*(EPSW - 1))/(epsn(-1)*nbeta) - (BETA*PHIP*epsn*lmult30(-1)*pinf^(EPSP - 2)*x2*(c(-1)/c)^GAMMA*(EPSP - 1))/(epsn(-1)*nbeta) - (BETA*EPSW*PHIW*epsn*g1*lmult17(-1)*pinf^(EPSW - 1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta) - (BETA*EPSP*PHIP*epsn*lmult29(-1)*pinf^(EPSP - 1)*x1*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 
lmult23*xi + epsi*lmult24*((PHII*(inv/inv(-1) - 1)^2)/2 + (PHII*inv*(inv/inv(-1) - 1))/inv(-1) - 1) + (BETA*epsn*lmult23(-1)*xi*(c(-1)/c)^GAMMA*(DELTA - 1))/(epsn(-1)*nbeta) - (BETA*PHII*epsi*epsn*inv^2*lmult24(-1)*xi*(c(-1)/c)^GAMMA*(inv/inv(-1) - 1))/(epsn(-1)*inv(-1)^2*nbeta*xi(-1)); 
lmult28 - (EPSP*lmult33*(PHIP - 1))/pstar^(EPSP + 1) - (lmult34*(EPSP - 1)*(PHIP - 1))/pstar^EPSP; 
lmult25*xi - lmult7(+1)*nbeta - lmult27*(f - (KAPPA*flag)/pinf) - lmult38*(BG + f) - (KAPPA*lmult35)/qlag - (BETA*KAPPA*epsn*lmult25(-1)*xi*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf); 
lmult7 + (lmult35*(KAPPA*q + 1))/qlag^2; 
(BETA*epsn(+1)*lmult37*(c/c(+1))^GAMMA*(phi - 1))/(epsn*pinf(+1)) - lmult8(+1)*nbeta - (BETA*epsn(+1)*lmult14*(c/c(+1))^GAMMA)/(epsn*pinf(+1)) - lmult1 + (BETA*ZETA*epsn(+1)*lmult36*(c/c(+1))^GAMMA*(phi - 1))/(epsn*pinf(+1)); 
lmult38 - lmult2; 
lmult35 - (lmult37(-1)*((BETA*epsn*phi(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf) - (BETA*epsn*epsf(-1)*phi(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*pinf)))/nbeta - (BETA*ZETA*epsn*lmult36(-1)*phi(-1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf); 
lmult8; 
lmult12 + omega_welf1; 
lmult13 + omega_welf2; 
lmult33 - lmult9(+1)*nbeta - lmult32*y; 
lmult9 - PHIP*lmult33*pinf^EPSP; 
lmult20 - hd*lmult19 - lmult10(+1)*nbeta; 
lmult10 - PHIW*lmult20*pinf^EPSW*(w/wlag)^EPSW; 
lmult22 - lmult11(+1)*nbeta + lmult20*((EPSW*wstar*(PHIW - 1))/(w^2*(wstar/w)^(EPSW + 1)) - (EPSW*PHIW*pinf^EPSW*vwlag*(w/wlag)^(EPSW - 1))/wlag) - (lmult21*(EPSW - 1))/w^EPSW - EPSW*hd*lmult18*w^(EPSW - 1) - EPSW*hd*lmult17*w^(EPSW - 1)*wh; 
lmult15 - hd*lmult17*w^EPSW; 
lmult11 + (PHIW*lmult21*pinf^(EPSW - 1)*(EPSW - 1))/wlag^EPSW + (EPSW*PHIW*lmult20*pinf^EPSW*vwlag*w*(w/wlag)^(EPSW - 1))/wlag^2; 
lmult16 - (lmult21*(EPSW - 1)*(PHIW - 1))/wstar^EPSW - (EPSW*lmult20*(PHIW - 1))/(w*(wstar/w)^(EPSW + 1)); 
lmult29 - (EPSP*lmult28)/(x2*(EPSP - 1)) - (BETA*PHIP*epsn*lmult29(-1)*pinf^EPSP*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 
lmult30 + (EPSP*lmult28*x1)/(x2^2*(EPSP - 1)) - (BETA*PHIP*epsn*lmult30(-1)*pinf^(EPSP - 1)*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta); 
lmult23*pk + lmult25*q + (BETA*epsn*lmult23(-1)*pk*(c(-1)/c)^GAMMA*(DELTA - 1))/(epsn(-1)*nbeta) - (BETA*KAPPA*epsn*lmult25(-1)*q*(c(-1)/c)^GAMMA)/(epsn(-1)*nbeta*pinf) + (BETA*PHII*epsi(+1)*epsn(+1)*inv(+1)^2*lmult24*pk(+1)*xi(+1)*(c/c(+1))^GAMMA*(inv(+1)/inv - 1))/(epsn*inv^2*xi^2) - (BETA*PHII*epsi*epsn*inv^2*lmult24(-1)*pk*(c(-1)/c)^GAMMA*(inv/inv(-1) - 1))/(epsn(-1)*inv(-1)^2*nbeta*xi(-1)); 
lmult39 - lmult30 - lmult29*mc - lmult32*vp; 
lmult31 + lmult32 + (lmult22*mc*(ALPHA - 1)*(SP + 1))/hd - (ALPHA*BETA*epsn*lmult23(-1)*mc*(c(-1)/c)^GAMMA*(SK + 1))/(epsn(-1)*k(-1)*nbeta); 
// 3  Utility 1: lmult3 
    Util1 = epsn*(c^(1-GAMMA)/(1-GAMMA) - PSI*h^(1+ETA)/(1+ETA)); 
// 4  Utility 2: lmult4 
    Util2 = epsn*(c^(1-GAMMA)/(1-GAMMA) - PSI*h^(1+ETA)/(1+ETA)); 
 
// MODEL 
// 5  Ex ante real rate 
//    real = r/pinf(+1); 
// 6  Consumption Euler equation 
    1 = BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA/pinf(+1)*r; 
// 7  Labor supply 
    wh = PSI*h^ETA*c^GAMMA; 
// 8  Nominal SDF 
//    lamn = BETA*epsn/epsn(-1)*(c(-1)/c)^GAMMA/pinf; 
// 9  Real SDF 
//    lam = lamn*pinf; 
// 10 Reset wage 
    wstar = (1+SW)*EPSW/(EPSW-1)*g1/g2; 
// 11 Wage numerator 
    g1 = wh*w^EPSW*hd+PHIW*BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA*pinf(+1)^EPSW*g1(+1); 
// 12 Wage denominator 
    g2 = w^EPSW*hd+PHIW*BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA*pinf(+1)^(EPSW-1)*g2(+1); 
// 13 Labor market clearing 
    h = hd*vw; 
// 14 Wage dispersion 
    vw = (1-PHIW)*(wstar/w)^(-EPSW)+PHIW*pinf^EPSW*(w/wlag)^EPSW*vwlag; 
// 15 Aggregate wage 
    w^(1-EPSW)=(1-PHIW)*wstar^(1-EPSW)+PHIW*pinf^(EPSW-1)*wlag^(1-EPSW); 
// 16 Labor demand 
    w = (1+SP)*mc*(1-ALPHA)*yw/hd; 
// 17 Capital return 
    pk*xi = BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA*((1+SK)*mc(+1)*ALPHA*yw(+1)/k+(1-DELTA)*pk(+1)*xi(+1)); 
// 18 Optimal investment 
     1 = pk*epsi*(1 - PHII*(inv/inv(-1)-1)*inv/inv(-1) - PHII/2*(inv/inv(-1)-1)^2) 
        + BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA*xi(+1)/xi*pk(+1)*epsi(+1)*PHII*(inv(+1)/inv-1)*(inv(+1)/inv)^2; 
// 19 Bond pricing 
    q*xi = BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA/pinf(+1)*(1+KAPPA*q(+1)*xi(+1)); 
// 20 Capital accumulation equation 
    k = (1-DELTA)*klag + epsi*(1-PHII/2*(inv/invlag-1)^2)*inv; 
// 21 Loan-in-advance constraint 
    inv = q*(f-KAPPA*flag/pinf); 
// 22 Reset price 
    pstar = EPSP/(EPSP-1)*x1/x2; 
// 23 Price numerator 
    x1 = mc*y+PHIP*BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA*pinf(+1)^EPSP*x1(+1); 
// 24 Price denominator 
    x2 = y+PHIP*BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA*pinf(+1)^(EPSP-1)*x2(+1); 
// 25 Aggregate production 
    yw = epsa*klag^ALPHA*hd^(1-ALPHA); 
// 26 Goods market clearing 
    yw = y*vp; 
// 27 Price dispersion 
    vp = (1-PHIP)*pstar^(-EPSP)+PHIP*pinf^EPSP*vplag; 
// 28 Inflation 
    1 = (1-PHIP)*pstar^(1-EPSP)+PHIP*pinf^(EPSP-1); 
// 29 Long-term rate 
    rl = (1+KAPPA*q)/qlag; 
// 30 Equity adjustment 
    1+PHIN*n/NSS*(n/NSS-1)+PHIN/2*(n/NSS-1)^2 = ZETA*BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA/pinf(+1)*(r+(rl(+1)-r)*phi); 
// 31 Risk-weighted leverage constraint 
    epsf*phi*BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA/pinf(+1)*rl(+1) = BETA*epsn(+1)/epsn*(c/c(+1))^GAMMA/pinf(+1)*(r+(rl(+1)-r)*phi); 
// 32 Risk-weighted leverage 
    phi*n = q*(f+BG)-re; 
// 33 Central bank balance sheet 
//    q*bcb = re; 
// 34 Debt-market clearing 
//    b = BG - bcb; 
// 35 Aggregate resource constraint 
    y = c + inv + PHIN/2*(n/NSS-1)^2; 
// 36 Long-term yield 
//    rlong = 1/q+KAPPA; 
// 37 Expectations hypothesis bond price 
//    qeh = (1+KAPPA*qeh(+1))/r; 
// 38 Expectations hypothesis long-term yield 
//    rlongeh = 1/qeh+KAPPA; 
// 39 Term premium 
//    tp = rlong - rlongeh; 
 
// WELFARE MEASURE 
// 40 Household welfare 
//    welfhh = Util1 + BETA*welfhh(+1); 
 
// 41 Expected inflation 
//    epinf = pinf(+1); 
// 42 Relative size of the balance sheet 
//    bal2y = re/y; 
// 43 Lag relative size of the balance sheet 
//    bal2yl = bal2y(-1); 
 
// EXOGENOUS PROCESSES 
// 44 Technology 
    log(epsa) = RHOA*log(epsa(-1)) + SIGA*ea; 
// 45 Preferences 
    log(epsn) = RHON*log(epsn(-1)) - SIGP*en; 
// 46 Financial 
    log(epsf) = (1-RHOF)*log(EPSF) + RHOF*log(epsf(-1)) - SIGF*ef; 
// 47 Marginal efficiency of investment 
    log(epsi) = RHOI*log(epsi(-1)) + SIGI*ei; 
 
// FLEXIBLE ECONOMY 
// 48 Interest rate policy 
//    log(rf) = RHOR*log(rf(-1)) + (1-RHOR)*(log(PINFSS/BETA) + UPSIPI*log(pinff/PINFSS) + UPSIY*log(yf/yf)); 
// 49 Balance sheet policy 
//    bal2yf = RESS/YSS; 
// 50 Consumption Euler equation 
//    1 = lamnf(+1)*rf; 
// 51 Labor supply 
//    whf = PSI*hf^ETA*cf^GAMMA; 
// 52 Nominal SDF 
//    lamnf = BETA*epsn/epsn(-1)*(cf(-1)/cf)^GAMMA/pinff; 
// 53 Real SDF 
//    lamf = lamnf*pinff; 
// 54 Reset wage 
//    wstarf = (1+SW)*EPSW/(EPSW-1)*whf; 
// 57 Labor market clearing 
//    hf = hdf*vwf; 
// 58 Wage dispersion 
//    vwf = (wstarf/wf)^(-EPSW); 
// 59 Aggregate wage 
//    wf^(1-EPSW)=wstarf^(1-EPSW); 
// 60 Labor demand 
//    wf = (1+SP)*mcf*(1-ALPHA)*ywf/hdf; 
// 61 Capital return 
//    pkf*xif = lamf(+1)*((1+SK)*mcf(+1)*ALPHA*ywf(+1)/kf+(1-DELTA)*pkf(+1)*xif(+1)); 
// 62 Optimal investment 
//     1 = pkf*epsi*(1 - PHII*(invf/invf(-1)-1)*invf/invf(-1) - PHII/2*(invf/invf(-1)-1)^2) 
//        + lamf(+1)*xif(+1)/xif*pkf(+1)*epsi(+1)*PHII*(invf(+1)/invf-1)*(invf(+1)/invf)^2; 
// 63 Bond pricing 
//    qf*xif = lamnf(+1)*(1+KAPPA*qf(+1)*xif(+1)); 
// 64 Capital accumulation equation 
//    kf = (1-DELTA)*kf(-1) + epsi*(1-PHII/2*(invf/invf(-1)-1)^2)*invf; 
// 65 Loan-in-advance constraint 
//    invf = qf*(ff-KAPPA*ff(-1)/pinff); 
// 66 Reset price 
//    pstarf = EPSP/(EPSP-1)*mcf; 
// 69 Aggregate production 
//    ywf = epsa*kf(-1)^ALPHA*hdf^(1-ALPHA); 
// 70 Goods market clearing 
//    ywf = yf*vpf; 
// 71 Price dispersion 
//    vpf = pstarf^(-EPSP); 
// 72 Inflation 
//    1 = pstarf^(1-EPSP); 
// 73 Long-term rate 
//    rlf = (1+KAPPA*qf)/qf(-1); 
// 74 Equity adjustment 
//    1+PHIN*nf/NSS*(nf/NSS-1)+PHIN/2*(nf/NSS-1)^2 = ZETA*lamnf(+1)*(rf+(rlf(+1)-rf)*phif); 
// 75 Risk-weighted leverage constraint 
//    epsf*phif*lamnf(+1)*rlf(+1) = lamnf(+1)*(rf+(rlf(+1)-rf)*phif); 
// 76 Risk-weighted leverage 
//    phif*nf = qf*(ff+BG)-ref; 
// 77 Central bank balance sheet 
//    qf*bcbf = ref; 
// 78 Debt-market clearing 
//    bf = BG - bcbf; 
// 79 Aggregate resource constraint 
//    yf = cf + invf +PHIN/2*(nf/NSS-1)^2; 
// 80 Relative balance sheet 
//    bal2yf = ref/yf; 
 
end; 
 
options_.noprint=1; 
steady; 
check; 
 
//shocks; 
//var ea = 1; 
//var en = 1; 
//var ef = 1; 
//var ei = 1; 
//end; 
 
// Calibration 
//stoch_simul(order=1,irf=21,nograph); 
//decomp = oo_.gamma_y{options_.ar+2}(4,:); 
//stoch_simul(order=2,periods=10000,irf=0,pruning,nograph); 
//stdyprem = [std(log(oo_.endo_simul(4,options_.drop+1:end))) std(log(oo_.endo_simul(6,options_.drop+1:end))) std(oo_.endo_simul(50,options_.drop+1:end))]; 
 
// Actual computations 
stoch_simul(order=2,irf=21,nograph); 
